/*
	Advanved Dialogs v1.0.7
	Copyright (C) 2005-2008 Jonas Gehring

	Advanced Dialogs is free software; you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Advanced Dialogs is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


// C Source File
// Created 24.11.2005; 03:23:31


#include <extgraph.h>							// ExtGraph by TI-Chess Team

#include "AdvDialogs.h"							// This should be obvious ;)
#include "Internal.h"							// This header should not be included in programs using Advanced Dialogs



// Activates a CheckBox
short AdvDlgCheckBox(ADVDIALOG *dialog, uchar tab, uchar line)
{
	void *kbq = kbd_queue();
	short key;
	short returnvalue = line;
	BOOL drawastab = FALSE;
	
	if (dialog->numtabs)
	{
		drawastab = TRUE;
	}

	// Mark field
	GrayDrawRect(dialog->right_x-12-(drawastab*3), dialog->top_y+7+2+(drawastab*10)+(line*8), dialog->right_x-4-(drawastab*3), dialog->top_y+15+2+(drawastab*10)+(line*8), COLOR_BLACK, RECT_EMPTY);	

	EXT_SETPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-14-(drawastab*3), dialog->top_y+12+(drawastab*10)+(line*8));
	EXT_SETPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-15-(drawastab*3), dialog->top_y+13+(drawastab*10)+(line*8));
	EXT_SETPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-14-(drawastab*3), dialog->top_y+14+(drawastab*10)+(line*8));

	EXT_SETPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-2-(drawastab*3), dialog->top_y+12+(drawastab*10)+(line*8));
	EXT_SETPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-1-(drawastab*3), dialog->top_y+13+(drawastab*10)+(line*8));
	EXT_SETPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-2-(drawastab*3), dialog->top_y+14+(drawastab*10)+(line*8));
	
	do 
	{	
		GetKey(kbq, &key);
		ClearKbdQueue();
		
		// Change value
		if (key == KEY_LEFT || key == KEY_RIGHT)
		{
			dialog->tabs[tab].elements[line].flag = !dialog->tabs[tab].elements[line].flag;
			
			GrayFastDrawLine(dialog->right_x-11-(drawastab*3), dialog->top_y+11+2+(drawastab*10)+(line*8), dialog->right_x-9-(drawastab*3), dialog->top_y+14+2+(drawastab*10)+(line*8), dialog->tabs[tab].elements[line].flag*3);	
			GrayFastDrawLine(dialog->right_x-9-(drawastab*3), dialog->top_y+14+2+(drawastab*10)+(line*8), dialog->right_x-5-(drawastab*3), dialog->top_y+8+2+(drawastab*10)+(line*8), dialog->tabs[tab].elements[line].flag*3);	
		}
		
		// Next element
		else if (key == KEY_DOWN)
		{
			// Find next interactive element
			do
			{
				returnvalue = (returnvalue+1) % dialog->tabs[tab].numelements;

			} while (dialog->tabs[tab].elements[returnvalue].element <= AD_TEXT);

			break;
		}
		
		// Previous element
		else if (key == KEY_UP)
		{
			// Find previous interactive element
			do
			{
				returnvalue = returnvalue ? returnvalue-1 : dialog->tabs[tab].numelements-1;
				
			} while (dialog->tabs[tab].elements[returnvalue].element <= AD_TEXT);

			break;
		}
		
		// Close Dialog (accept)
		if (key == KEY_ENTER)
		{
			returnvalue = dialog->tabs[tab].numelements;
			break;
		}
		// Close Dialog (decline)	
		else if (key == KEY_ESC)
		{
			returnvalue = -1;
			break;
		}
		
		// Next Tab
		else if (key == KEY_APPS && drawastab)
		{
			returnvalue = NEXTTAB;
			break;
		}
		
	} while (TRUE);

	// Unmark field
	GrayDrawRect(dialog->right_x-12-(drawastab*3), dialog->top_y+7+2+(drawastab*10)+(line*8), dialog->right_x-4-(drawastab*3), dialog->top_y+15+2+(drawastab*10)+(line*8), COLOR_LIGHTGRAY, RECT_EMPTY);	

	// Delete "arrows"
	EXT_CLRPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-14-(drawastab*3), dialog->top_y+12+(drawastab*10)+(line*8));
	EXT_CLRPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-15-(drawastab*3), dialog->top_y+13+(drawastab*10)+(line*8));
	EXT_CLRPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-14-(drawastab*3), dialog->top_y+14+(drawastab*10)+(line*8));

	EXT_CLRPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-2-(drawastab*3), dialog->top_y+12+(drawastab*10)+(line*8));
	EXT_CLRPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-1-(drawastab*3), dialog->top_y+13+(drawastab*10)+(line*8));
	EXT_CLRPIX(GrayGetPlane(DARK_PLANE), dialog->right_x-2-(drawastab*3), dialog->top_y+14+(drawastab*10)+(line*8));
	
	return returnvalue;			
}


// Activates an InputBox
short AdvDlgInputBox(ADVDIALOG *dialog, uchar tab, uchar line)
{
	void *kbq = kbd_queue();
	short returnvalue = line;
	short key, pos = 0, show = 0, width, strwidth = DrawStrWidth(dialog->tabs[tab].elements[line].text, F_4x6);
	BOOL drawastab = FALSE;
	short drawastab10, drawastab3;
	short line8 = line*8;
	
	if (dialog->numtabs)
	{
		drawastab = TRUE;
	}
		
	pos = strlen(dialog->tabs[tab].elements[line].inputbuffer);
	
	drawastab10 = drawastab*10;
	drawastab3 = drawastab*3;
	width = dialog->right_x-10-(drawastab3) - 4 -(dialog->left_x+5+strwidth);

	// Input loop (adapted from ExciteBike 68k by Travis Fischer
	do
	{
		GrayDrawRect(dialog->left_x+2+(drawastab3)+strwidth + 4, dialog->top_y+8+(line8)+2+(drawastab10), dialog->right_x-5-(drawastab3), dialog->top_y+14+(line8)+2+(drawastab10), COLOR_WHITE, RECT_FILLED);	
		GrayDrawRect(dialog->left_x+2+(drawastab3)+strwidth + 3, dialog->top_y+7+(line8)+2+(drawastab10), dialog->right_x-4-(drawastab3), dialog->top_y+15+(line8)+2+(drawastab10), COLOR_BLACK, RECT_EMPTY);	
		
		// Scroll input if neccessary
		show = 0;
		while (DrawStrWidth(&dialog->tabs[tab].elements[line].inputbuffer[show], F_4x6) > width)
		{
			show++;
		}
	
		GrayDrawStrExt(dialog->left_x+2+(drawastab3)+strwidth + 4, dialog->top_y+9+(line8)+2+(drawastab10), &dialog->tabs[tab].elements[line].inputbuffer[show], A_NORMAL, F_4x6);
		
		GrayDrawStrExt(dialog->left_x+2+(drawastab3)+strwidth + 4 + DrawStrWidth(&dialog->tabs[tab].elements[line].inputbuffer[show], F_4x6), dialog->top_y+9+(line8)+2+(drawastab10), "_", A_NORMAL, F_4x6); 
		
		GetKey(kbq, &key);
		
		// Allow number if waiting for number
		// Allow text and numbers if waiting for text
		if (pos < dialog->tabs[tab].elements[line].inputsize && pos >= 0 && (isdigit(key) || (!dialog->tabs[tab].elements[line].flag && ((toupper(key) >= 'A' && toupper(key) <= 'Z') || key == ' ' || key == 92))))
		{
			dialog->tabs[tab].elements[line].inputbuffer[pos++] = key;		
		}
		
		// Delete single char
		if (key == KEY_BACKSPACE && pos)
		{
			pos--;
		}
		
		// Delete whole string
		else if (key == KEY_CLEAR)
		{
			pos = 0;
		}
		
		// Next element
		else if (key == KEY_DOWN)
		{
			// Find next interactive element
			do
			{
				returnvalue = (returnvalue+1) % dialog->tabs[tab].numelements;
			}
			while (dialog->tabs[tab].elements[returnvalue].element <= AD_TEXT);

			break;
		}
		
		// Previous element
		else if (key == KEY_UP)
		{
			// Find previous interactive element
			do
			{
				returnvalue = returnvalue ? returnvalue-1 : dialog->tabs[tab].numelements-1;
			}
			while (dialog->tabs[tab].elements[returnvalue].element <= AD_TEXT);

			break;
		}
		
		// Close Dialog (accept)
		else if (key == KEY_ENTER)
		{
			returnvalue = dialog->tabs[tab].numelements;
			break;
		}
		// Close Dialog (dialog)	
		else if (key == KEY_ESC)
		{
			returnvalue = -1;
			break;
		}
		
		// Next tab
		else if (key == KEY_APPS)
		{
			returnvalue = NEXTTAB;
			break;
		}
		
		// End the string at the current position (saves space)
		dialog->tabs[tab].elements[line].inputbuffer[pos]='\0';
		
	} while (!pos);
	
	GrayDrawRect(dialog->left_x+2+(drawastab3)+DrawStrWidth(dialog->tabs[tab].elements[line].text, F_4x6) + 3, dialog->top_y+7+(line8)+2+(drawastab10), dialog->right_x-(drawastab3)-4, dialog->top_y+15+(line8)+2+(drawastab10), COLOR_LIGHTGRAY, RECT_EMPTY);
	GrayDrawRect(dialog->left_x+2+(drawastab3)+DrawStrWidth(dialog->tabs[tab].elements[line].text, F_4x6) + 4, dialog->top_y+8+(line8)+2+(drawastab10), dialog->right_x-5-(drawastab3), dialog->top_y+14+(line8)+2+(drawastab10), COLOR_WHITE, RECT_FILLED);
	GrayDrawStrExt(dialog->left_x+2+(drawastab3)+DrawStrWidth(dialog->tabs[tab].elements[line].text, F_4x6) + 4, dialog->top_y+9+(line8)+2+(drawastab10), &dialog->tabs[tab].elements[line].inputbuffer[show], A_NORMAL, F_4x6);
	
	return returnvalue;
}


// Activates a DropDown-menu
short AdvDlgDropDown(ADVDIALOG *dialog, uchar tab, uchar line)
{
	void *kbq = kbd_queue();
	short returnvalue = line;
	short key, selected, i, width, strwidth = DrawStrWidth(dialog->tabs[tab].elements[line].text, F_4x6);
	BOOL drawastab = FALSE;
	uchar drawastab10, drawastab3;
	short line8 = line*8;
	
	if (dialog->numtabs)
	{
		drawastab = TRUE;
	}
	
	// Save screen contents if neccessary
	if (!dialog->savescreen)
	{
		SaveScreen();
	}
		
	selected = *dialog->tabs[tab].elements[line].selected;
	
	drawastab10 = drawastab*10;
	drawastab3 = drawastab*3;
	width = (dialog->left_x+10+(drawastab3)+strwidth)- (dialog->right_x-5-(drawastab3));

	// Find widest element
	for (i = dialog->tabs[tab].elements[line].flag; i--; )
	{
		if (DrawStrWidth(dialog->tabs[tab].elements[line].itemlist[i], F_4x6) + 1 > width)
		{
			width = DrawStrWidth(dialog->tabs[tab].elements[line].itemlist[i], F_4x6) + 1;
		}
	}

	// Pop-Up the menu
	GrayDrawRect(dialog->left_x+10+(drawastab3)+strwidth, dialog->top_y+8+2+(drawastab10)+(line8), dialog->left_x+10+(drawastab3)+strwidth+width, dialog->top_y+8+2+(drawastab*10)+(line8)+((dialog->tabs[tab].elements[line].flag)*6), COLOR_WHITE, RECT_FILLED);	
	GrayDrawRect(dialog->left_x+9+(drawastab3)+strwidth, dialog->top_y+7+2+(drawastab10)+(line8), dialog->left_x+11+(drawastab3)+strwidth+width, dialog->top_y+9+2+(drawastab*10)+(line8)+((dialog->tabs[tab].elements[line].flag)*6), COLOR_BLACK, RECT_EMPTY);	

	for (i = dialog->tabs[tab].elements[line].flag; i--; )
	{
		GrayDrawStrExt(dialog->left_x+10+(drawastab3)+strwidth, dialog->top_y+9+2+(drawastab10)+(line8)+(i*6), dialog->tabs[tab].elements[line].itemlist[i], A_NORMAL, F_4x6);
	}
	
	GrayInvertRect(dialog->left_x+10+(drawastab*3)+strwidth,
		dialog->top_y+10+(drawastab10)+(line8)+(selected*6),
		dialog->left_x+10+(drawastab3)+strwidth+width,
		dialog->top_y+10+(drawastab10)+(line8)+(selected*6)+6);	
	
	do
	{
		GetKey(kbq, &key);

		// Select next item
		if (key == KEY_RIGHT)
		{
			GrayInvertRect(dialog->left_x+10+(drawastab3)+strwidth,
				dialog->top_y+10+(drawastab10)+(line8)+(selected*6),
				dialog->left_x+10+(drawastab3)+strwidth+width,
				dialog->top_y+10+(drawastab10)+(line8)+(selected*6)+6);	
		
			selected = (selected+1) % dialog->tabs[tab].elements[line].flag;
			
			GrayInvertRect(dialog->left_x+10+(drawastab3)+strwidth,
				dialog->top_y+10+(drawastab10)+(line8)+(selected*6),
				dialog->left_x+10+(drawastab3)+strwidth+width,
				dialog->top_y+10+(drawastab10)+(line8)+(selected*6)+6);			
			
		}

		// Select previous item
		if (key == KEY_LEFT)
		{
			GrayInvertRect(dialog->left_x+10+(drawastab3)+strwidth,
				dialog->top_y+10+(drawastab10)+(line8)+(selected*6),
				dialog->left_x+10+(drawastab3)+strwidth+width,
				dialog->top_y+10+(drawastab10)+(line8)+(selected*6)+6);			
			
			selected = selected ? selected-1 : dialog->tabs[tab].elements[line].flag-1;
			
			GrayInvertRect(dialog->left_x+10+(drawastab3)+strwidth,
				dialog->top_y+10+(drawastab10)+(line8)+(selected*6),
				dialog->left_x+10+(drawastab3)+strwidth+width,
				dialog->top_y+10+(drawastab10)+(line8)+(selected*6)+6);			
		}
		
		// Next element
		if (key == KEY_DOWN)
		{
			// Find next interactive element
			do
			{
				returnvalue = (returnvalue+1) % dialog->tabs[tab].numelements;

			} while (dialog->tabs[tab].elements[returnvalue].element <= AD_TEXT);

			break;
		}
		
		// Previous element
		else if (key == KEY_UP)
		{
			// Find previous interactive element
			do
			{
				returnvalue = returnvalue ? returnvalue-1 : dialog->tabs[tab].numelements-1;
				
			} while (dialog->tabs[tab].elements[returnvalue].element <= AD_TEXT);

			break;
		}
		
		// Close Dialog (accept)
		if (key == KEY_ENTER)
		{
			ClearKbdQueue();

			returnvalue = dialog->tabs[tab].numelements;
			break;
		}
		// Close Dialog (decline)	
		else if (key == KEY_ESC)
		{
			ClearKbdQueue();

			returnvalue = -1;
			break;
		}
		
		// Next Tab
		else if (key == KEY_APPS && drawastab)
		{
			ClearKbdQueue();
			
			returnvalue = NEXTTAB;
			break;
		}
		
	} while (TRUE);
	
	*dialog->tabs[tab].elements[line].selected = selected;
	
	if (returnvalue != NEXTTAB && returnvalue != -1 && returnvalue != dialog->tabs[tab].numelements)
	{
		// Restore components
		FastCopyScreen_R(tscr, GrayGetPlane(LIGHT_PLANE));
		FastCopyScreen_R(tscr+sizeof(LCD_BUFFER), GrayGetPlane(DARK_PLANE));
		AdvDlgDrawTab(dialog, tabcounter);
	}
	
	return returnvalue;
}

